package automat;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * <p>Title: kos</p><br>
 * <p>Author: Josef Jebavy</p><br>
 *
 * <p>Description: Hlavni okno s vybranym zbozim</p><br>
 *
 * <p>Copyright: tento program je  siren pod licenci GPL v2 nebo novejší</p><br>
 *
 * <p>Company: Multi</p><br>
 * <p>Jabber: multi(at)jabber.sh.cvut.cz</p><br>
 * <p>ICQ: 281213073</p><br>
 * <p>e-mail:joepage@quick.cz</p><br>
 * <p>web:<a href="www.sweb.cz/joepage">www.sweb.cz/joepage</a></p><br>
 * @author Josef Jebavy
 * @version 1.8
 */
public class Automat

    extends JFrame {
  Container kontak;

  JLabel utrataJL;
  JButton vysypatBT;

  int utrataInt;

  VstupniData vstup;
  Nabidka[] nabidka;
  JLabel[] prazdnyJL;

  int prazdny = 3;

  JButton pokladnaBT;
  Pokladna pokladna;
  Kom kom;
  InOut inOut;
  /**
   * konstruktor
   *
   */
  public Automat() {

    //**vola konstruktor predka
     super("Automat");

    //**tvori objekt vstupni data s parametrem data
     this.vstup = new VstupniData(kom.data);

    setSize(500, 40 * vstup.length);

    setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE /*Exit()*/);
    setVisible(true);

    //**pole objektu tlacitek s vlastnostmi
     this.nabidka = new Nabidka[vstup.length];

    //**kontejner
     kontak = getContentPane();

    //**rozházení do Layoutu
     // FlowLayout rozmisteni = new FlowLayout();
     GridLayout rozmisteni = new GridLayout(1 * vstup.length + 2, 3);

    kontak.setLayout(rozmisteni);

    for (int i = 0; i < vstup.length; i++) {
      //**naplneni pole objektu zbozim i s popisem
       nabidka[i] = new Nabidka(vstup.nazev[i], vstup.cena[i], vstup.obrazek[i]);
      //**pridani objektu zbozi
       kontak.add(nabidka[i].nabitkaPriBT);
      kontak.add(nabidka[i].nabitkaLA);
      kontak.add(nabidka[i].nabitkaOdBT);

      nabidka[i].nabitkaLA.setForeground(Color.blue.darker());
      //nabitka[i].nabitkaLA.setForeground(Color.white);
      //nabitka[i].nabitkaBT.setBackground(Color.black);
      //**vystredeni trlacitek
       nabidka[i].nabitkaPriBT.setHorizontalAlignment(nabidka[i].nabitkaPriBT.
           CENTER);
      nabidka[i].nabitkaOdBT.setHorizontalAlignment(nabidka[i].nabitkaOdBT.
          CENTER);
      nabidka[i].nabitkaLA.setHorizontalAlignment(nabidka[i].nabitkaLA.CENTER);
      //*nasloucha pocitani utrty - aby se automatickz prepocitala
       nabidka[i].nabitkaPriBT.addActionListener(new PosluchacPri(i));
      nabidka[i].nabitkaOdBT.addActionListener(new PosluchacOd(i));

    }
    //**konec nabydky

     //**prazdny JLabel
      this.prazdnyJL = new JLabel[prazdny];
    for (int i = 0; i < prazdnyJL.length; i++) {
      prazdnyJL[i] = new JLabel();
      kontak.add(prazdnyJL[i]);

    }

    //**
     pokladnaBT = new JButton(kom.pokladna);
    pokladnaBT.addActionListener(new PosluchacPokladnaBT( /*nabidka*/));

    //**utrata JLabel
     utrataJL = new JLabel(kom.utrata + utrataInt + " " + kom.mena);

    //**vysypani kose
     vysypatBT = new JButton(kom.vysypatKos);
    vysypatBT.addActionListener(new PosluchacVysypatBT());

    //**nahazeni do kontaku
     kontak.add(pokladnaBT);
    kontak.add(utrataJL);
    kontak.add(vysypatBT);
    utrataJL.setHorizontalAlignment(utrataJL.CENTER);

    //**konec kontaku
     setContentPane(kontak);

    //**pokladna
     pokladna = new Pokladna(nabidka, utrataInt);
    pokladna.zpetBT.addActionListener(new PosluchacZpetBT());

  }

  /**
   * posluchac  pridani
   */

  class PosluchacPri
      implements ActionListener {
    int i;
    PosluchacPri(int i) {
      this.i = i;
    }

    public void actionPerformed(ActionEvent e) {

      nabidka[i].Pridat();
      SpocitatUtratu();

    }

  }

  /**
   *SpocitatUtratu
   *
   */
  public void SpocitatUtratu() {

    utrataInt = 0;
    for (int i = 0; i < vstup.length; i++) {

      utrataInt += nabidka[i].cena * nabidka[i].mnozstvi;
    }

    utrataJL.setText(kom.utrata + utrataInt + " " + kom.mena);

  }

  /**
   *
   * posluchac odebirani
   */
  class PosluchacOd

      implements ActionListener {
    int i;
    PosluchacOd(int i) {
      this.i = i;
    }

    public void actionPerformed(ActionEvent e) {
      //**ulrychleni
       if (nabidka[i].mnozstvi > 0) {
         nabidka[i].Odebrat();
         SpocitatUtratu();
       }
    }
  }

  /**
   *
   *posluchac vysipani kose
   */

  class PosluchacVysypatBT
      implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      VysypatKos();
    }
  }

  /**
   * posluchac pokladny
   */
  class PosluchacPokladnaBT

      implements ActionListener {

    public void actionPerformed(ActionEvent e) {
      pokladna.utrata = utrataInt;
      Skryt(true);
      Uctenka();
    }

  }

  /**
   * Uctenka
   */
  private void Uctenka() {
    // int platit=0;
    inOut.ZapsatDoSouboru("", kom.ucet, true);
    for (int i = 0; i < nabidka.length; i++) {
      if (nabidka[i].mnozstvi > 0) {

        int celkem = nabidka[i].mnozstvi * nabidka[i].cena;
        String mezera = " ";
      //  System.out.println(nabidka[i].nazev.length());
        for (int j = 15; j > nabidka[i].nazev.length(); j--) {
          mezera += " ";
        }
        String string = nabidka[i].nazev + mezera + nabidka[i].mnozstvi + " " +
            kom.kusu +"  "+kom.po+" "+
            nabidka[i].cena + " " + kom.mena + " "+kom.tjs + celkem + kom.mena;
        inOut.ZapsatDoSouboru(string, kom.ucet, false);
        // platit=+celkem;
      }
    }
    inOut.ZapsatDoSouboru("\n" + kom.celPlatit + utrataInt + kom.mena, kom.ucet, false);

  }

  /**
   * VysypatKos
   */
  public void VysypatKos() {
    //*vynuluje data nabidky
     utrataInt = 0;
    for (int i = 0; i < vstup.length; i++) {
      nabidka[i].mnozstvi = 0;
      nabidka[i].nabitkaLA.setText(nabidka[i].nazev + " " + nabidka[i].cena +
                                   " " + kom.mena + "  " + nabidka[i].mnozstvi +
                                   "x");

      utrataJL.setText(kom.utrata + utrataInt + " " + kom.mena);

    }
    //*vysype obrazky z kose
     nabidka[0].kos.Vysypat();

  }

  /**
   * Skryt
   *
   * @param b boolean
   */
  private void Skryt(boolean b) {
    setVisible(!b);
    nabidka[0].kos.setVisible(!b);
    pokladna.setVisible(b);
  }

  /**
   *
   *posluchac PosluchacZpetBT
   */

  class PosluchacZpetBT
      implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      Skryt(false);
    }
  }

  public static void main(String[] args) {

    new Automat().setVisible(true);

  }
}
